#include <toneAC.h>

long randNumber; //used for storing random number from seed

int state = HIGH;      // the current state of the output pin
int buttonReading;           // the current buttonReading from the input pin
int previous = LOW;    // the previous buttonReading from the input pin

// the follow variables are long's because the time, measured in miliseconds,
// will quickly become a bigger number than can be stored in an int.
long time = 0;         // the last time the output pin was toggled
long debounce = 200;   // the debounce time, increase if the output flickers

int photocellReading;
int batteryReading;

int timer1 = 0;
int timer2 = 50;

// the setup function runs once when you press reset or power the board
void setup() {
  Serial.begin(9600);
  // initialize digital pins as an output.
  pinMode(6, OUTPUT);
  pinMode(7, OUTPUT);
  pinMode(8, OUTPUT);

  pinMode(2, INPUT);
  // if analog input pin 1 is unconnected, random analog
  // noise will cause the call to randomSeed() to generate
  // different seed numbers each time the sketch runs.
  // randomSeed() will then shuffle the random function.
  randomSeed(analogRead(1));

  for (int x = 0; x < 3; x++) {
    flash(100, 300);
  }

/*  batteryReading = analogRead(A0);
  float voltage = batteryReading * (2.5 / 1023.0);
  Serial.println(voltage);*/
}

// the loop function runs over and over again forever
void loop() {

  // Get the updated values :
  buttonReading = digitalRead(2);
  photocellReading = analogRead(A3);


  // if the input just went from LOW and HIGH and we've waited long enough
  // to ignore any noise on the circuit, toggle the output pin and remember
  // the time
  if (buttonReading == HIGH && previous == LOW && millis() - time > debounce) {
    flash(300, 300);
    if (state == HIGH) {
      state = LOW;
      timer1 = 0;
      timer2 = 50;
      startup();
    }
    else {
      state = HIGH;
      timer1 = 0;
      timer2 = 50;
      for (int x = 0; x < 3; x++) {
        startup();
      }
    }
    time = millis();
  }


  if (timer1 >= timer2) {
    if (timer2 <= 320) {
      timer2 = timer2 * 2;
    }
    if (state == HIGH) {
      // get a random number from 1 to 3
      randNumber = random(1, 4);
      switch (randNumber) {
        case 1:     //do something when var equals 1
          {
            randNumber = random(1, 4);
            for (int x = 0; x < randNumber; x++) {
              sirene();
            }
          }
          break;
        case 2:      //do something when var equals 2
          {
            randNumber = random(1, 4);
            for (int x = 0; x < randNumber; x++) {
              updown();
            }
          }
          break;
        case 3:    //do something when var equals 3
          {
            randNumber = random(1, 4);
            for (int x = 0; x < randNumber; x++) {
              whistle();
            }
          }
          break;
        default:
          // if nothing else matches, do the default
          // default is optional
          break;
      }
      if (photocellReading < 150) {
        randNumber = random(1, 4);
        switch (randNumber) {
          case 1:     //do something when var equals 1
            {
              for (int x = 0; x < 50; x++) {
                flash(50, 50);
              }
            }

            break;
          case 2:      //do something when var equals 2
            {
              for (int x = 0; x < 5; x++) {
                flash(1000, 1000);
              }
            }
            break;
          case 3:    //do something when var equals 3
            {
              flash(10000, 1000);
            }
            break;
          default:
            // if nothing else matches, do the default
            // default is optional
            break;
        }

      }
    }
    timer1 = 0;
  }




  float voltage = batteryReading * (5.0 / 1023.0);





  previous = buttonReading;
  timer1 = timer1 + 1;
  delay(100); //* good night

}

void whistle () {
  for (unsigned long freq = 125; freq <= 15000; freq += 10) {
    toneAC(freq); // Play the frequency (125 Hz to 15 kHz sweep in 10 Hz steps).
    delay(1);     // Wait 1 ms so you can hear it.
  }
  noToneAC();
}

void updown () {
  for (unsigned long freq = 125; freq <= 15000; freq += 5) {
    toneAC(freq); // Play the frequency (125 Hz to 15 kHz sweep in 10 Hz steps).
    delay(1);     // Wait 1 ms so you can hear it.
  }
  for (unsigned long freq = 15000; freq >= 125; freq -= 5) {
    toneAC(freq); // Play the frequency (15 kHz to 125 Hz sweep in 10 Hz steps).
    delay(1);     // Wait 1 ms so you can hear it.
  }
  noToneAC();
}

void sirene () {
  toneAC(2000, 10, 500);
  delay(1);
  toneAC(5000, 10, 500);
  delay(1);
  noToneAC();
}

void startup () {
  toneAC(5000);
  delay(100);
  noToneAC();
}


void flash (int x, int y) {
  digitalWrite(6, HIGH);   // turn the LED on (HIGH is the voltage level)
  digitalWrite(7, HIGH);
  digitalWrite(8, HIGH);
  delay(x);              // wait for a second
  digitalWrite(6, LOW);    // turn the LED off by making the voltage LOW
  digitalWrite(7, LOW);
  digitalWrite(8, LOW);
  delay(y);
}

